<!DOCTYPE html>
    <html>
    <head>
        <meta http-equiv="Content-type" content="text/html;charset=UTF-8">
        <title>What is EF</title>
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/katex@0.10.0/dist/katex.min.css" integrity="sha384-9eLZqc9ds8eNjO3TmqPeYcDj8n+Qfa4nuSiGYa6DjLNcv9BtN69ZIulL9+8CqC9Y" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/gh/Microsoft/vscode/extensions/markdown-language-features/media/markdown.css">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/gh/Microsoft/vscode/extensions/markdown-language-features/media/highlight.css">
        <link href="https://cdn.jsdelivr.net/npm/katex-copytex@latest/dist/katex-copytex.min.css" rel="stylesheet" type="text/css">
        <style>
.task-list-item { list-style-type: none; } .task-list-item-checkbox { margin-left: -20px; vertical-align: middle; }
</style>
        <style>
            body {
                font-family: -apple-system, BlinkMacSystemFont, 'Segoe WPC', 'Segoe UI', 'Ubuntu', 'Droid Sans', sans-serif;
                font-size: 14px;
                line-height: 1.6;
            }
            code div {
                padding: 10px;
                border: 1px solid;
                border-color: #B3AFAA;
                background-color: rgba(0, 0, 0, 0.1);
                border-radius: 10px;
            }
            .hljs-params {
                color: black;
            }
            .hljs-title {
                color: green;
            }
            .hljs-function {
                color: black;
            }

        </style>
        
        <script src="https://cdn.jsdelivr.net/npm/katex-copytex@latest/dist/katex-copytex.min.js"></script>
    </head>
    <body>
        <h1 id="what-is-ef">What is EF</h1>
<p>Entity Framework is the latest technology provided by <a href="http://ADO.net">ADO.net</a> for accessinng database.</p>
<ul>
<li>It is an ORM tool.</li>
<li>It provides easy and automated way of mapping between Classes and Relations.</li>
<li>It auto generates most of the data-access code.</li>
</ul>
<h1 id="why-use-ef">Why use EF</h1>
<p>It provides full intelliSense support for columns names and table names</p>
<h1 id="what-is-ef-core">What is EF Core</h1>
<ul>
<li>EF Core is an ORM tool</li>
<li>EF Core has almost same interfaces as EF6.X</li>
<li>EF Core can be used to access NpSQL DB. Where EF6.X cannot</li>
<li>EF Core can run on Windows, Linux and Apple. Where as EF6.X is only for Windows.</li>
<li>There are two approaches of working with EF Core
<ul>
<li>Code-First: generate database tables from classes</li>
<li>Database-First (Reverse Engineering): generate classes from database tables</li>
</ul>
</li>
</ul>
<h2 id="code-first">Code-First</h2>
<p><img src="./img/CodeFirstExample.jpg" alt="CodeFirstExample">
In the <strong>Code-First</strong> approach, you focus on your application and start creating classes for it and we cal them as business entities or business objects</p>
<h1 id="getting-started-with-ef-core">Getting started with EF Core</h1>
<ul>
<li><strong>Start a new .Net Core Console App</strong>: New project -&gt; .Net Core -&gt; Console App</li>
<li><strong>Install -Nuget Packages</strong>: Microsoft.EntityFrameworkCore.SqlServer: Right click on Project (Solution Explorer) -&gt; manage nugetPackages -&gt; search package -&gt; Install</li>
<li><strong>Create an Entity <em>Department</em></strong>: in the Program.cs file inside the namespace we can create our entity:<pre><code class="language-c#"><div><span class="hljs-keyword">class</span> <span class="hljs-title">Department</span>
{
    [<span class="hljs-meta">Key</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> DepartmentId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Name { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Description { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
}
</div></code></pre>
</li>
<li><strong>Create a <em>DbContext</em> class</strong>:  <em>DbContext</em> is the top-level object that manages database connection and provides the functionalities on database like Create, Read, Update and Delete operations. It is our main data access class, using which we perform all the operations, should be inherited from DbContext<pre><code class="language-c#"><div><span class="hljs-keyword">class</span> <span class="hljs-title">OrganizationContext</span>:<span class="hljs-title">DbContext</span>
{
}
</div></code></pre>
Our <em>OrganizationContext</em> class should hav DbSet<TEntity> properties for each entity or object<pre><code class="language-c#"><div><span class="hljs-keyword">class</span> <span class="hljs-title">OrganizationContext</span>:<span class="hljs-title">DbContext</span>
{
    <span class="hljs-keyword">public</span> DbSet&lt;Department&gt; Department { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
}    
</div></code></pre>
DbSet is used to perform CRUD operations on TEntity. (see Creating and updating Database for the full code)</li>
<li><strong>Create a new Department</strong>: In the main method<pre><code class="language-c#"><div><span class="hljs-keyword">var</span> context = <span class="hljs-keyword">new</span> OrganizationContext();
<span class="hljs-keyword">var</span> department = <span class="hljs-keyword">new</span> Department
{
    <span class="hljs-comment">//DepartmentId auto-increment</span>
    Name = <span class="hljs-string">"Dev"</span>,
    Description = <span class="hljs-string">"Roba"</span>
};
context.Department.Add(department);
context.SaveChanges();
</div></code></pre>
First of all we need to initialize the context, then we can create our department.
When we have our object we can add it to the context then commit the changes to the DB with SaveChanges</li>
<li><strong>Select all</strong>:<pre><code class="language-c#"><div><span class="hljs-keyword">var</span> allDepartments = context.Department.ToList();
</div></code></pre>
Using ToList on the DbSet<Department> it will perform the query to get all elements in the table</li>
</ul>
<h2 id="creating-and-updating-database">Creating and updating Database</h2>
<ul>
<li><strong>Install - Nuget Package <em>Microsoft.EntityFrameworkCore.Tools</em></strong> (Without VS also install <em>Microsoft.EntityFrameworkCore.Tools.DotNet</em>)</li>
<li><strong>Override <em>OnConfiguring()</em> method in <em>OrganizationContext</em> with connection string</strong>:<pre><code class="language-c#"><div><span class="hljs-keyword">private</span> <span class="hljs-keyword">const</span> <span class="hljs-keyword">string</span> ConnectionString =
    <span class="hljs-string">"Data Source=10.0.75.1,1433;Initial Catalog=EFCoreFirstApp;Persist Security "</span> +
    <span class="hljs-string">"Info=True;User ID=SA;Password=sa2016!NSI"</span>;
<span class="hljs-function"><span class="hljs-keyword">protected</span> <span class="hljs-keyword">override</span> <span class="hljs-keyword">void</span> <span class="hljs-title">OnConfiguring</span>(<span class="hljs-params">DbContextOptionsBuilder optionsBuilder</span>)</span>
{
    optionsBuilder
        .UseSqlServer(ConnectionString);
}
</div></code></pre>
</li>
<li><strong>Open Package Manager Console and run below commands</strong>:<pre><code><div>add-migration &lt;name&gt; //build a migration with the differences between the latest migrations context state and the current context state
update-database //apply all the migrations unapplied to the database
</div></code></pre>
</li>
<li><strong>Alternative without VS - Open a terminal inside the project forlder and run</strong>:<pre><code><div>dotnet ef migrations add First //like add-migration
dotnet ef database update //like update-database
</div></code></pre>
</li>
</ul>
<p>After that we can notice that it created our database with the Departments table.
It also create a new Folder <strong>Migrations</strong> with many files:</p>
<ul>
<li>20190326114438_First.cs: contains the actions to update the database UP and DOWN (to revert changes)</li>
<li>20190326114438_First.Designer.cs: describe the context after the migration</li>
<li>OrganizationContextModelSnapshot.cs: describe the actual context state</li>
</ul>
<p>If we add a property in the Department class and another class:</p>
<pre><code class="language-c#"><div><span class="hljs-keyword">class</span> <span class="hljs-title">Department</span>
{
    [<span class="hljs-meta">Key</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> DepartmentId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Name { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Description { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> DateTime DateOfFormation { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
}
<span class="hljs-keyword">class</span> <span class="hljs-title">Employee</span>
{
    [<span class="hljs-meta">Key</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> EmployeeId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Name { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Gender { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">float</span> Salary { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
}
</div></code></pre>
<p>and repeat the two commands to update database (add-migration, update-database), it will create two more files:</p>
<ul>
<li>20190326121429_Second.cs</li>
<li>20190326121429_Second.Designer.cs
and it will updte the OrganizationContextModelSnapshot.cs with the current context state.</li>
</ul>
<h2 id="revert-database-changes">Revert Database changes</h2>
<p>To remove a migration first of all we need to revert the changes on the database:</p>
<pre><code><div>update-database &lt;TargetMigrationName&gt; 
</div></code></pre>
<p>or</p>
<pre><code><div>dotnet ef database update &lt;TargetMigrationName&gt;
</div></code></pre>
<p>In our case:</p>
<pre><code><div>update-database 20190326114438_First
</div></code></pre>
<p>After that we can remove it (the following command remove the latest migration and update the context snapshot)</p>
<pre><code><div>remove-migration
</div></code></pre>
<p>or</p>
<pre><code><div>dotnet ef migrations remove
</div></code></pre>
<h2 id="how-to-generate-sql">How to generate .sql</h2>
<pre><code><div>script-migration
</div></code></pre>
<p>or</p>
<pre><code><div>dotnet ef migrations script
</div></code></pre>
<h1 id="class-design-techniques">Class Design Techniques</h1>
<p><strong>One class for each object</strong></p>
<h2 id="relationship-1m">Relationship (1:M)</h2>
<p>For example one <em>Department</em> can have many <em>Employee</em> so we add the <strong>List of Employees</strong> in the <em>Department</em> class, the  <strong>DepartmentId</strong> and the <strong>Department</strong> properties in the <em>Employee</em> class</p>
<pre><code class="language-c#"><div><span class="hljs-keyword">class</span> <span class="hljs-title">Department</span>
{
    [<span class="hljs-meta">Key</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> DepartmentId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Name { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Description { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> DateTime DateOfFormation { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    
    <span class="hljs-comment">//Relationship with employee property</span>
    <span class="hljs-keyword">public</span> List&lt;Employee&gt; Employees { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
}

<span class="hljs-keyword">class</span> <span class="hljs-title">Employee</span>
{
    [<span class="hljs-meta">Key</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> EmployeeId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Name { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Gender { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">float</span> Salary { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    
    <span class="hljs-comment">//Relationship properties</span>
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> DepartmentId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> Department Department { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
}
</div></code></pre>
<h2 id="relationship-mm">Relationship (M:M)</h2>
<p>If an <em>Employee</em> can have many <em>Department</em> we need to add a new Cross Table class <strong>EmployeeDepartment</strong>, one <strong>List of EmployeeDepartment</strong> in the <em>Department</em> class and one <strong>List of EmployeeDepartment</strong> in the <em>Employee</em> class:</p>
<pre><code class="language-c#"><div><span class="hljs-keyword">class</span> <span class="hljs-title">Department</span>
{
    [<span class="hljs-meta">Key</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> DepartmentId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Name { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Description { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> DateTime DateOfFormation { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }

    <span class="hljs-comment">//Relationship properties M:M</span>
    <span class="hljs-keyword">public</span> List&lt;EmployeeDepartment&gt; EmployeeDepartments { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
}

<span class="hljs-keyword">class</span> <span class="hljs-title">Employee</span>
{
    [<span class="hljs-meta">Key</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> EmployeeId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Name { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> Gender { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">float</span> Salary { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    
    <span class="hljs-comment">//Relationship properties M:M</span>
    <span class="hljs-keyword">public</span> List&lt;EmployeeDepartment&gt; EmployeeDepartments { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
}

<span class="hljs-keyword">class</span> <span class="hljs-title">EmployeeDepartment</span>
{
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> EmployeeDepartmentId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> EmployeeId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> Employee Employee { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> DepartmentId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> Department Department { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
}
</div></code></pre>
<h1 id="data-annotations-attribute">Data annotations attribute</h1>
<p><a href="https://docs.microsoft.com/it-it/ef/ef6/modeling/code-first/data-annotations">https://docs.microsoft.com/it-it/ef/ef6/modeling/code-first/data-annotations</a><br>
Data annotations redefine object adding attributes.
We have:</p>
<ul>
<li><strong>Table()</strong>: specify table properties</li>
<li><strong>Columnt()</strong>: specify column properties</li>
<li><strong>Key</strong>: mark as primary key</li>
<li><strong>Required</strong>: mark as required</li>
<li><strong>MaxLength()</strong>: specify the max lenght</li>
<li><strong>DatabaseGenerated()</strong>: If you're mapping your Code First classes to tables that contain computed columns, you don't want Entity Framework to try to update those columns. But you do want EF to return those values from the database after you've inserted or updated data. You can use the DatabaseGenerated annotation to flag those properties in your class.</li>
<li><strong>ConcurrencyCheck</strong>: the ConcurrencyCheck annotation allows you to flag one or more properties to be used for concurrency checking in the database when a user edits or deletes an entity.The command will attempt to locate the correct row by filtering not only on the key value but also on the original value of the property with this attribute. If someone has changed the blogger name for that blog in the meantime, this update will fail and you’ll get a DbUpdateConcurrencyException that you'll need to handle.</li>
<li><strong>NotMapped</strong>: you can mark any properties that do not map to the database with the NotMapped annotation.</li>
<li><strong>ForeignKey</strong>: mark the property as foreign key</li>
</ul>
<p>Ex.</p>
<pre><code class="language-c#"><div>[<span class="hljs-meta">Table(<span class="hljs-meta-string">"Author"</span>)</span>]
<span class="hljs-keyword">class</span> <span class="hljs-title">Author</span>
{
    [<span class="hljs-meta">Key</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> AuthorId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }

    [<span class="hljs-meta">MaxLength(15)</span>]
    [<span class="hljs-meta">Required</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> FirstName { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }

    [<span class="hljs-meta">MaxLength(15),Required</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> LastName { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }

    [<span class="hljs-meta">NotMapped</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> FullName
    {
        <span class="hljs-keyword">get</span> { <span class="hljs-keyword">return</span> FirstName + <span class="hljs-string">""</span> + LastName; }
    }

    <span class="hljs-keyword">public</span> List&lt;Book&gt; Books { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
}

[<span class="hljs-meta">Table(<span class="hljs-meta-string">"Book"</span>)</span>]
<span class="hljs-keyword">class</span> <span class="hljs-title">Book</span>
{
    [<span class="hljs-meta">Key,Column(Order =0)</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> BookId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }

    [<span class="hljs-meta">Column(Order =1)</span>]
    [<span class="hljs-meta">Required</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">string</span> BookName { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }

    [<span class="hljs-meta">Column(Order = 2)</span>]
    [<span class="hljs-meta">ConcurrencyCheck</span>]
    [<span class="hljs-meta">Required</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">double</span> PricePerUnit { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }

    [<span class="hljs-meta">Column(Order =3)</span>]
    [<span class="hljs-meta">DatabaseGenerated(DatabaseGeneratedOption.Computed)</span>]
    <span class="hljs-keyword">public</span> DateTime CreatedOn { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }

    [<span class="hljs-meta">Column(Order = 4)</span>]
    [<span class="hljs-meta">ForeignKey(<span class="hljs-meta-string">"Author"</span>)</span>]
    <span class="hljs-keyword">public</span> <span class="hljs-keyword">int</span> AuthorId { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }

    <span class="hljs-keyword">public</span> Author Author { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
}
</div></code></pre>
<h1 id="fluent-api">Fluent API</h1>
<p><a href="http://www.entityframeworktutorial.net/efcore/fluent-api-in-entity-framework-core.aspx">http://www.entityframeworktutorial.net/efcore/fluent-api-in-entity-framework-core.aspx</a><br>
Is an alternative to DataAnnotations to set certain Database-EF properties.
To use it we have to override the OnModelCreating method int the context:</p>
<pre><code class="language-c#"><div><span class="hljs-keyword">class</span> <span class="hljs-title">ShopDbContext</span> : <span class="hljs-title">DbContext</span>
{
    <span class="hljs-keyword">private</span> <span class="hljs-keyword">const</span> <span class="hljs-keyword">string</span> ConnectionString = <span class="hljs-string">""</span>;
    <span class="hljs-function"><span class="hljs-keyword">protected</span> <span class="hljs-keyword">override</span> <span class="hljs-keyword">void</span> <span class="hljs-title">OnConfiguring</span>(<span class="hljs-params">DbContextOptionsBuilder optionsBuilder</span>)</span>
    {
        optionsBuilder.UseSqlServer(ConnectionString);
    }
    <span class="hljs-keyword">public</span> DbSet&lt;Author&gt; Authors { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }
    <span class="hljs-keyword">public</span> DbSet&lt;Book&gt; Books { <span class="hljs-keyword">get</span>; <span class="hljs-keyword">set</span>; }

    <span class="hljs-function"><span class="hljs-keyword">protected</span> <span class="hljs-keyword">override</span> <span class="hljs-keyword">void</span> <span class="hljs-title">OnModelCreating</span>(<span class="hljs-params">ModelBuilder modelBuilder</span>)</span>
    {
        <span class="hljs-comment">//Do the same thing of ForeignKey annotations on AuthorId</span>
         modelBuilder
            .Entity&lt;Book&gt;()
            .HasOne(x =&gt; x.Author)
            .WithMany(x =&gt; x.Books);
    }
}
</div></code></pre>
<h1 id="query-log">Query log</h1>
<p>We need to add a log system to check the exat query that EF perform and when.<br>
EF Core logging currently requires an ILoggerFactory which is itself configured with one or more ILoggerProvider.</p>
<ul>
<li>Install nuGet : Microsoft.Extensions.Logging.Debug</li>
<li>Inside the context class insert:<pre><code class="language-c#"><div>    <span class="hljs-function"><span class="hljs-keyword">private</span> ILoggerFactory <span class="hljs-title">GetLoggerFactory</span>(<span class="hljs-params"></span>)</span>
    {
        IServiceCollection serviceCollection = <span class="hljs-keyword">new</span> ServiceCollection();
        serviceCollection.AddLogging(builder =&gt;
            builder
                .AddDebug()
                .AddFilter(DbLoggerCategory.Database.Command.Name, LogLevel.Information));
        <span class="hljs-keyword">return</span> serviceCollection
            .BuildServiceProvider()                     
            .GetService&lt;ILoggerFactory&gt;()
    }
</div></code></pre>
</li>
<li>Inside the OnConfiguring method insert:<pre><code class="language-c#"><div>    optionsBuilder
        .UseLoggerFactory(GetLoggerFactory())
        .UseSqlServer(ConnectionString);
</div></code></pre>
</li>
</ul>
<h1 id="crud">CRUD</h1>
<p><em><strong>Tip</strong>:</em>
It is good and wise to dispose the context object after using it. The DbContext class take from IDisposable so it can be manually removed from memory using the .Dispose() method.
Another way to free the allocated memory is to use the <strong>using</strong>:</p>
<pre><code class="language-c#"><div><span class="hljs-keyword">using</span> (<span class="hljs-keyword">var</span> shopDbContext = <span class="hljs-keyword">new</span> ShopDbContext())
{
    <span class="hljs-keyword">var</span> author = shopDbContext.Authors.Find(<span class="hljs-number">4</span>);

    <span class="hljs-comment">//shopDbContext.Authors.Remove(author);</span>
    <span class="hljs-comment">//shopDbContext.SaveChanges();</span>
    <span class="hljs-comment">//or</span>
    shopDbContext.Remove&lt;Author&gt;(author);
    shopDbContext.SaveChanges();
}
</div></code></pre>
<h2 id="insert">Insert</h2>
<ul>
<li>Create an object</li>
<li>Add it to the context</li>
<li>Save the context changes</li>
</ul>
<pre><code class="language-c#"><div><span class="hljs-keyword">var</span> author = <span class="hljs-keyword">new</span> Author() { FirstName = <span class="hljs-string">"Manzoor"</span>, LastName = <span class="hljs-string">"Ahmed"</span> };

<span class="hljs-comment">//shopDbContext.Authors.Add(author);</span>
<span class="hljs-comment">//shopDbContext.SaveChanges();</span>
<span class="hljs-comment">//OR</span>
shopDbContext.Add(author); <span class="hljs-comment">//The set deducet from the object type passed in this case author</span>
shopDbContext.SaveChanges();
</div></code></pre>
<h2 id="delete">Delete</h2>
<ul>
<li>Load the object from the database</li>
<li>Remove it from the context</li>
<li>Save the context changes</li>
</ul>
<pre><code class="language-c#"><div><span class="hljs-keyword">var</span> author = shopDbContext
    .Authors
    .FirstOrDefault(x =&gt; x.AuthorId == <span class="hljs-number">4</span>) <span class="hljs-comment">//Where expression;</span>

<span class="hljs-comment">//shopDbContext.Authors.Remove(author);</span>
<span class="hljs-comment">//shopDbContext.SaveChanges();</span>
<span class="hljs-comment">//OR</span>
shopDbContext.Remove&lt;Author&gt;(author);
shopDbContext.SaveChanges();
</div></code></pre>
<h2 id="update">Update</h2>
<h3 id="connected-approach">Connected approach</h3>
<ul>
<li>Load the object from the database</li>
<li>Change it</li>
<li>Save the context changes</li>
</ul>
<pre><code class="language-c#"><div><span class="hljs-keyword">var</span> author = shopDbContext
    .Authors
    .FirstOrDefault(x =&gt; x.AuthorId == <span class="hljs-number">3</span>);
author.FirstName = <span class="hljs-string">"Jack"</span>;
shopDbContext.SaveChanges();
</div></code></pre>
<h3 id="disconnected-approach">Disconnected approach</h3>
<pre><code class="language-c#"><div><span class="hljs-keyword">private</span> ShopDbContext Context;

<span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">OnLoad</span>(<span class="hljs-params"></span>)</span>
{
    Context = <span class="hljs-keyword">new</span> ShopDbContext();
}
<span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">Update</span>(<span class="hljs-params">Author author</span>)</span>
{
    <span class="hljs-comment">//Context.Authors.Update(author);</span>
    <span class="hljs-comment">//Context.SaveChanges();</span>
    <span class="hljs-comment">//OR</span>
    Context.Update&lt;Author&gt;(author);
    Context.SaveChanges();
}
</div></code></pre>
<p><strong>The disconnected approach is also applicable to delete</strong></p>
<h2 id="select">Select</h2>
<p>Examples:</p>
<pre><code class="language-c#"><div> Console.Write(<span class="hljs-string">"Enter Book Id : "</span>);
<span class="hljs-keyword">var</span> bookId = <span class="hljs-keyword">int</span>.Parse(Console.ReadLine());

<span class="hljs-keyword">using</span> (<span class="hljs-keyword">var</span> shopDbContext = <span class="hljs-keyword">new</span> ShopDbContext())
{
    <span class="hljs-comment">//By primary key</span>
    <span class="hljs-keyword">var</span> book = shopDbContext.Books.Find(bookId);

    book = shopDbContext
        .Books
        .FirstOrDefault(x =&gt; Math.Abs(x.PricePerUnit - <span class="hljs-number">1373</span>) &lt; <span class="hljs-number">0.001</span>); <span class="hljs-comment">// it will perform the query with top (1) returning the first element or the default value for Book class </span>
    book = shopDbContext
        .Books
        .SingleOrDefault(x =&gt; Math.Abs(x.PricePerUnit - <span class="hljs-number">1373</span>) &lt; <span class="hljs-number">0.001</span>); <span class="hljs-comment">//same as FirstOrDefault but the query have top(2) because this method throw an exception if the query returns multiple rows.</span>
    <span class="hljs-keyword">if</span> (book != <span class="hljs-literal">null</span>)
    {
        Console.WriteLine(<span class="hljs-string">"BookId:{0} Name:{1} Price:{2}"</span>
            , book.BookId, book.BookName, book.PricePerUnit);
    }
    <span class="hljs-keyword">else</span>
    {
        Console.WriteLine(<span class="hljs-string">"Book Not Found"</span>);
    }

    <span class="hljs-comment">//select count(*) from Book</span>
    <span class="hljs-keyword">var</span> numberOfBooks = shopDbContext.Books.Count();
    Console.WriteLine(<span class="hljs-string">"Number Of Books are "</span> + numberOfBooks);

    <span class="hljs-comment">//selece * from Book where PricePerUnit&gt;5000</span>
    <span class="hljs-keyword">var</span> list2 = shopDbContext.Books.Where(x =&gt; x.PricePerUnit &gt; <span class="hljs-number">5000</span>).ToList();
    <span class="hljs-comment">//selece * from Book where AuthorId = 3</span>
    <span class="hljs-keyword">var</span> list3 = shopDbContext.Books.Where(x =&gt; x.AuthorId == <span class="hljs-number">3</span>).ToList();

    <span class="hljs-comment">//Get All the books whose author's first name is "Manzoor"</span>
    <span class="hljs-keyword">var</span> authorId = shopDbContext
        .Authors
        .FirstOrDefault(x =&gt; x.FirstName == <span class="hljs-string">"Manzoor"</span>)?<span class="hljs-comment">//? is the null propagation operator if firstordefault return null all expression will result null</span>
        .AuthorId;
    <span class="hljs-comment">//Select * from Book where AuthorId = authorId</span>
    <span class="hljs-keyword">var</span> list4 = shopDbContext.Books.Where(x =&gt; x.AuthorId == authorId).ToList();

    <span class="hljs-comment">//Select * from Book join Author on Book.AuthorId = Author.Id where Author.FirstName = 'Manzoor'</span>
    <span class="hljs-keyword">var</span> list = shopDbContext.Books.Where(x =&gt; x.Author.FirstName == <span class="hljs-string">"Manzoor"</span>).ToList();

    <span class="hljs-keyword">foreach</span> (<span class="hljs-keyword">var</span> bookElement <span class="hljs-keyword">in</span> list)
    {
        Console.WriteLine(<span class="hljs-string">"BookId:{0} Name:{1} Price:{2}"</span>, bookElement.BookId, bookElement.BookName, bookElement.PricePerUnit);
    }

    Console.ReadLine();
}
</div></code></pre>
<h1 id="immediate-mode-deferred-mode">Immediate mode, Deferred mode</h1>
<h2 id="immediate-mode">Immediate mode</h2>
<pre><code class="language-c#"><div><span class="hljs-comment">//Immediate Mode - List, IEnumerable</span>
<span class="hljs-keyword">var</span> list = context.Books.ToList();
</div></code></pre>
<p>The query is executed during the declaration.<br>
Try:</p>
<pre><code class="language-c#"><div><span class="hljs-keyword">var</span> list = context.Books.ToList();
list.Add(<span class="hljs-keyword">new</span> Book() {BookName = <span class="hljs-string">"Prova"</span>, PricePerUnit = <span class="hljs-number">5000</span>, AuthorId = <span class="hljs-number">1</span>});
context.SaveChanges();
</div></code></pre>
<p>Do this insert the new book in the database ? (NO)
This will:</p>
<pre><code class="language-c#"><div>List&lt;Book&gt; list = context.Books.ToList();
context.Books.Add(<span class="hljs-keyword">new</span> Book() {BookName = <span class="hljs-string">"Prova"</span>, PricePerUnit = <span class="hljs-number">5000</span>, AuthorId = <span class="hljs-number">1</span>});
context.SaveChanges();
</div></code></pre>
<p>Using the ToList() method it will <strong>perform the query</strong> but the new list is detached from the dbset: if we add or remove item is only for the list not for the context.
To restrict the user to add new item we can use IEnumerable() instead of List</p>
<pre><code class="language-c#"><div>IEnumerable&lt;Book&gt; list = context.Books.ToList();
</div></code></pre>
<p>IEnumerable is <strong>read-only</strong> List is not.</p>
<h2 id="deferred-mode">Deferred mode</h2>
<pre><code class="language-c#"><div><span class="hljs-comment">//Deffered Mode - IEnumerable, IQueryable</span>
IEnumerable&lt;Book&gt; list = context.Books;
<span class="hljs-keyword">foreach</span> (<span class="hljs-keyword">var</span> book <span class="hljs-keyword">in</span> list)
{
    ...
}
</div></code></pre>
<p>The query is prepared during the declaration and it is performed every time before use.
The variable, in this case, cannot be a List.
Try:</p>
<pre><code class="language-c#"><div>IEnumerable&lt;Book&gt; list = context.Books;
<span class="hljs-keyword">foreach</span> (<span class="hljs-keyword">var</span> item <span class="hljs-keyword">in</span> list.Where(x =&gt; x.AuthorId != <span class="hljs-number">1</span>))
{
    ...
}
</div></code></pre>
<p>What query it will produce? It will do the same query as before so it load all records into memory then perform other operations.
If we use IQueryable instead of IEnumerable:</p>
<pre><code class="language-c#"><div>IQueryable&lt;Book&gt; list = context.Books;
<span class="hljs-keyword">foreach</span> (<span class="hljs-keyword">var</span> item <span class="hljs-keyword">in</span> list.Where(x =&gt; x.AuthorId != <span class="hljs-number">1</span>))
{
    ...
}
</div></code></pre>
<p>It will performe the query with the where (AuthorId != 1) clause included.</p>
<h3 id="summary">Summary</h3>
<ul>
<li><strong>Immediate mode</strong>:
<ul>
<li>In immediate mode of query execution query gets executed whereverthe query is defined. It is achived with the help of linq method like ToList(), Count().</li>
<li>Query object holds the data wich reduces number of hits to database on every request.</li>
<li>Return type can be <strong>List</strong> or <strong>IEnumerable</strong></li>
</ul>
</li>
<li><strong>Deferred mode</strong>:
<ul>
<li>In deferred mode query is executed whenever we use it (whenever we acces the field)</li>
<li>Here query object hits the server on every request which reduces the size of query object in memory.</li>
<li>Return type can be <strong>IQueryable</strong> or <strong>IEnumerable</strong></li>
</ul>
</li>
</ul>
<h1 id="eager-loading-explicit-loading-lazy-loading">Eager Loading, Explicit Loading, Lazy Loading</h1>
<p>For the reverse list property like Books inside Author we can have different loading methods:<br>
<strong>Eager loading:</strong> load the collections specified with the <em>Include()</em> method with the main query using joins</p>
<pre><code class="language-c#"><div><span class="hljs-keyword">var</span> context = <span class="hljs-keyword">new</span> ShopDbContext();
<span class="hljs-comment">//Select * from Author a join Book b on a.Id = b.AuthorId</span>
<span class="hljs-keyword">var</span> authors = context.Authors.Include(x =&gt; x.Books).ToList();
<span class="hljs-keyword">foreach</span> (<span class="hljs-keyword">var</span> author <span class="hljs-keyword">in</span> authors)
{
    <span class="hljs-keyword">foreach</span> (<span class="hljs-keyword">var</span> book <span class="hljs-keyword">in</span> author.Books)
    {
        Console.WriteLine(book.BookId + <span class="hljs-string">" "</span> + book.BookName)
    }
}
</div></code></pre>
<p><strong>Explicit loading:</strong> load only the main entity (in this case Author) and when we need Author's collections we have to load them explicitly.</p>
<pre><code class="language-c#"><div><span class="hljs-keyword">var</span> context = <span class="hljs-keyword">new</span> ShopDbContext();
<span class="hljs-comment">//Select * from Author</span>
<span class="hljs-keyword">var</span> authors = context.Authors.ToList();
<span class="hljs-keyword">foreach</span> (<span class="hljs-keyword">var</span> author <span class="hljs-keyword">in</span> authors)
{
    <span class="hljs-comment">//It will now hit SQL Server to execute query</span>
    <span class="hljs-comment">//Selecct * from Book where AuthorId = @CurrentForeachAuthor.Id</span>
    context.Entry(author).Collection(x =&gt; x.Books).Load();
    <span class="hljs-keyword">foreach</span> (<span class="hljs-keyword">var</span> book <span class="hljs-keyword">in</span> author.Books)
    {
        Console.WriteLine(book.BookId + <span class="hljs-string">" "</span> + book.BookName)
    }
}
</div></code></pre>
<p><strong>Lazy loading:</strong> same behavior as Explicit loading.<br>
To use lazy loading we need to add the Microsoft.EntityFrameworkCore.Proxies package to the project and the following command in the context OnConfiguring method</p>
<pre><code class="language-c#"><div><span class="hljs-comment">//using Microsoft.EntityFrameworkCore.Proxies</span>
optionsBuilder.UseLazyLoadingProxies();
</div></code></pre>
<p>and then:</p>
<pre><code class="language-c#"><div><span class="hljs-keyword">var</span> context = <span class="hljs-keyword">new</span> ShopDbContext();
<span class="hljs-keyword">var</span> authors = context.Authors.ToList();
<span class="hljs-keyword">foreach</span> (<span class="hljs-keyword">var</span> author <span class="hljs-keyword">in</span> authors)
{
    <span class="hljs-comment">//LazyLoading: related employees of D gets loaded automatically</span>
    <span class="hljs-keyword">foreach</span> (<span class="hljs-keyword">var</span> book <span class="hljs-keyword">in</span> author.Books)
    {
        Console.WriteLine(book.BookId + <span class="hljs-string">" "</span> + book.BookName)
    }
}
</div></code></pre>
<p>Using Lazy loading <strong>ALL</strong> navigation properties must be <em>virtual</em></p>
<h1 id="default-transaction">Default transaction</h1>
<p>Say we are inserting 1 record and updating 2 records and finally calling SaveChanges(); by default SaveChanges() are applied in a transaction which means if any of the operations fail then te entire transaction is rolled back.<br>
You can also manually control transaction if you have multiple SaveChages() method call.</p>
<hr>
<hr>
<hr>
<hr>
<h1 id="esercizio-finale">Esercizio finale</h1>
<p>Lo scopo è creare una struttura che contenga la mappatura delle entità e le sue logiche fondamentali (CRUD, comportamenti specifici ecc...) che sia applicabile ad ogni progetto di interfacciamento con l'utente.
Dividere la soluzione in più progetti:</p>
<ul>
<li>Entities: contiene tutte le classi che servono a mappare il db</li>
<li>Services: contiene tutte le logiche delle entità (CRUD)</li>
<li>Interfaces: contiene le interfaccie dei servizi (tipo i file .h del C)</li>
</ul>
<p>Lo scopo è costruie un sistema di interfacciamento con il db replicando una base dati per gestire le timbrature:</p>
<ul>
<li>Mappatura entità:
<ul>
<li>Utente</li>
<li>Commessa</li>
<li>IntervalloTemporale</li>
</ul>
</li>
<li>CRUD: operazioni di crud sulle entità</li>
<li>Calcolo ore giornaliere dati data inizio e data fine</li>
</ul>
<h3 id="entities"><strong>Entities</strong></h3>
<p>Non deve avere dipendenze e contiene la mappatura delle entità del database.</p>
<ul>
<li>Aggiungere i pacchetti necessari.</li>
<li>Classe base Entity di partenza**(Facoltativo)**.</li>
<li>Una classe/file per ogni entità.</li>
<li>Specificare i campi e relative relazioni utilizzando dataannotations</li>
</ul>
<h3 id="services"><strong>Services</strong></h3>
<p>Azioni relative alle entità (Es. CRUD)</p>
<ul>
<li>Creazione del Contesto (Classe Repository)</li>
<li>Aggiungere logging <strong>(Facoltativo)</strong></li>
<li>Aggiungere riferimento al progetto Entity</li>
<li>Aggiungere DbSet nella classe repository per ogni Entità</li>
<li>Collegamento e aggiornamento del database (nel caso in cui il progetto di partenza e il progetto con il repository sono diversi bisogna specificare due parametri nei comandi di migrazione: --Project e --StartupProject)<br>
È inoltre necessario che lo startupproject referenzi il project<pre><code><div>add-migration -Project Services -StartupProject FinalEFConsole
update-database -Project Services -StartupProject FinalEFConsole

</div></code></pre>
</li>
<li>Crud di base partendo dalla classe Entity <strong>(Si può generalizzare utilizzando parametri di tipo ma potrebbe essere troppo complicato quindi Facoltativa)</strong>
<ul>
<li>Save (Insert e Update)</li>
<li>LoadAll</li>
<li>LoadSingle</li>
<li>Delete</li>
<li>LoadAndSelect</li>
</ul>
</li>
<li>Servizio per ogni entitá</li>
</ul>
<h3 id="interfaces"><strong>Interfaces</strong></h3>
<p>Contiene la descrizione dell'interfacciamento con i services</p>
<ul>
<li>Interfaccia per ogni servizio</li>
</ul>
<h3 id="parte-console">Parte console:</h3>
<ul>
<li>Caricare un entità (differenza tra savechanges, aggiunta al contesto ecc ecc)</li>
<li>Stampare un entità a video (lettura singola e lista)</li>
<li>Stampare le ore giornaliere</li>
</ul>

    </body>
    </html>